# StochasticDiffEqCore.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEqCore.jl is the core infrastructure package for stochastic differential equation (SDE) solvers within the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo. It provides the shared infrastructure used by all SDE solver subpackages, including:

- `__init` and `__solve` entry points for `SDEProblem` and `RODEProblem`
- Abstract algorithm types (`StochasticDiffEqAlgorithm`, `StochasticDiffEqAdaptiveAlgorithm`, etc.)
- Algorithm traits (`alg_order`, `isadaptive`, `alg_compatible`, etc.)
- `SDEIntegrator` type alias and SDE-specific integrator utilities
- Iterated integral approximation interface
- Composite algorithm support (`StochasticCompositeAlgorithm`)

This package is not intended to be used directly by end users. Instead, use one of the solver subpackages (e.g., `StochasticDiffEqLowOrder`, `StochasticDiffEqHighOrder`) or the umbrella package [StochasticDiffEq.jl](https://github.com/SciML/StochasticDiffEq.jl).

## Solver Subpackages

| Package | Solvers |
|---------|---------|
| StochasticDiffEqLowOrder | EM, EulerHeun, LambaEM, LambaEulerHeun, SimplifiedEM, SplitEM, RKMil, RKMilCommute, PCEuler |
| StochasticDiffEqHighOrder | SRI, SRIW1, SRIW2, SOSRI, SOSRI2, SRA, SRA1, SRA2, SRA3, SOSRA, SOSRA2 |
| StochasticDiffEqMilstein | RKMilGeneral, WangLi3SMil_A-F |
| StochasticDiffEqROCK | SROCK1, SROCK2, KomBurSROCK2, SROCKC2, SROCKEM, SKSROCK, TangXiaoSROCK2 |
| StochasticDiffEqImplicit | ImplicitEM, ImplicitEulerHeun, ImplicitRKMil, STrapezoid, SImplicitMidpoint, ISSEM, ISSEulerHeun, SKenCarp |
| StochasticDiffEqWeak | DRI1, RI1, RI3, RI5, RI6, RDI1WM-RDI4WM, W2Ito1, RS1, RS2, PL1WM, NON, COM, IRI1, and more |
| StochasticDiffEqIIF | IIF1M, IIF2M, IIF1Mil |
| StochasticDiffEqLeaping | TauLeaping, CaoTauLeaping, ImplicitTauLeaping, ThetaTrapezoidalTauLeaping |
| StochasticDiffEqRODE | RandomEM, RandomHeun, RandomTamedEM, BAOAB |

function _get_alias_noise_from_kwargs(; alias_noise = nothing, alias = nothing, kwargs...)
    if alias_noise !== nothing
        return alias_noise
    elseif alias !== nothing && hasproperty(alias, :alias_noise) && alias.alias_noise !== nothing
        return alias.alias_noise
    else
        return true
    end
end

function DiffEqBase.__solve(
        prob::DiffEqBase.AbstractRODEProblem,
        alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm};
        kwargs...
    )
    integrator = DiffEqBase.__init(prob, alg; kwargs...)
    solve!(integrator)
    if prob isa DiffEqBase.AbstractRODEProblem &&
            typeof(prob.noise) == typeof(integrator.sol.W) &&
            _get_alias_noise_from_kwargs(; kwargs...)
        copy!(prob.noise, integrator.sol.W)
    end
    return integrator.sol
end

# More specific method for JumpProblem to win over JumpProcesses.jl's ambiguity fix dispatch
function DiffEqBase.__solve(
        prob::JumpProblem,
        alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm};
        merge_callbacks = true, kwargs...
    )
    kwargs = DiffEqBase.merge_problem_kwargs(prob; merge_callbacks, kwargs...)
    integrator = DiffEqBase.__init(prob, alg; kwargs...)
    solve!(integrator)
    if concrete_prob(prob) isa DiffEqBase.AbstractRODEProblem &&
            typeof(concrete_prob(prob).noise) == typeof(integrator.sol.W) &&
            _get_alias_noise_from_kwargs(; kwargs...)
        copy!(concrete_prob(prob).noise, integrator.sol.W)
    end
    return integrator.sol
end

# Make it easy to grab the RODEProblem/SDEProblem/DiscreteProblem from the keyword arguments
concrete_prob(prob) = prob
concrete_prob(prob::JumpProblem) = prob.prob

"""
    _resolve_rng(rng, seed, prob) -> (rng, seed, rng_provided)

Resolve the RNG and seed for an SDE/RODE integration from the user-provided
`rng` and `seed` kwargs plus the problem's stored seed.
"""
function _resolve_rng(rng, seed, prob)
    if rng !== nothing
        if !(rng isa Random.AbstractRNG)
            throw(
                ArgumentError(
                    "`rng` must be an `AbstractRNG`, got $(typeof(rng))."
                )
            )
        end
        if rng isa Random.TaskLocalRNG
            _seed = rand(rng, UInt64)
            return Random.Xoshiro(_seed), _seed, true
        end
        return rng, UInt64(0), true
    end
    _seed = if iszero(seed)
        if (!(prob isa DiffEqBase.AbstractRODEProblem) || iszero(prob.seed))
            seed_multiplier() * rand(UInt64)
        else
            prob.seed
        end
    else
        seed
    end
    return Random.Xoshiro(_seed), _seed, false
end

"""
    _z_prototype(alg, rand_prototype, iip::Bool) -> rand_prototype2

Compute the Z process prototype for algorithms that need an extra Brownian process.
Default: use rand_prototype itself as Z prototype (same shape as W).
Solver subpackages override this for algorithms with special Z requirements
(e.g., PL1WM, RKMilGeneral, W2Ito1).
"""
function _z_prototype(alg, rand_prototype, iip::Bool)
    return rand_prototype
end

function DiffEqBase.__init(
        _prob::Union{DiffEqBase.AbstractRODEProblem, JumpProblem},
        alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm};
        kwargs...
    )
    return _sde_init(_prob, alg; kwargs...)
end

function _sde_init(
        _prob::Union{DiffEqBase.AbstractRODEProblem, JumpProblem},
        alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm};
        saveat = (),
        tstops = (),
        d_discontinuities = (),
        save_idxs = nothing,
        save_everystep = isempty(saveat),
        save_noise = save_everystep && (
            typeof(concrete_prob(_prob).f) <: Tuple ?
                DiffEqBase.has_analytic(concrete_prob(_prob).f[1]) :
                DiffEqBase.has_analytic(concrete_prob(_prob).f)
        ),
        save_on = true,
        save_start = save_everystep || isempty(saveat) || saveat isa Number ? true :
            concrete_prob(_prob).tspan[1] in saveat,
        save_end = nothing,
        callback = nothing,
        dense = false,
        calck = false,
        dt = eltype(concrete_prob(_prob).tspan)(0),
        adaptive = isadaptive(_prob, alg),
        gamma = isadaptive(alg) ? 9 // 10 : 0,
        abstol = nothing,
        reltol = nothing,
        qmin = qmin_default(alg),
        qmax = qmax_default(alg),
        qsteady_min = qsteady_min_default(alg),
        qsteady_max = qsteady_max_default(alg),
        beta2 = nothing,
        beta1 = nothing,
        qoldinit = isadaptive(alg) ? 1 // 10^4 : 0,
        controller = nothing,
        fullnormalize = true,
        failfactor = 2,
        delta = delta_default(alg),
        maxiters = adaptive ? 1000000 : typemax(Int),
        dtmax = eltype(concrete_prob(_prob).tspan)((concrete_prob(_prob).tspan[end] - concrete_prob(_prob).tspan[1])),
        dtmin = DiffEqBase.prob2dtmin(concrete_prob(_prob)),
        internalnorm = ODE_DEFAULT_NORM,
        isoutofdomain = ODE_DEFAULT_ISOUTOFDOMAIN,
        unstable_check = ODE_DEFAULT_UNSTABLE_CHECK,
        verbose = true, force_dtmin = false,
        timeseries_errors = true, dense_errors = false,
        advance_to_tstop = false, stop_at_next_tstop = false,
        initialize_save = true,
        progress = false, progress_steps = 1000, progress_name = "SDE",
        progress_message = ODE_DEFAULT_PROG_MESSAGE,
        progress_id = :StochasticDiffEq,
        userdata = nothing,
        save_discretes = true,
        initialize_integrator = true,
        seed = UInt64(0),
        rng = nothing,
        alias = nothing,
        initializealg = OrdinaryDiffEqCore.DefaultInit(),
        kwargs...
    )
    # NOTE: JumpProblem kwargs merge is already done by init_call / __solve
    # before reaching _sde_init. DO NOT call merge_problem_kwargs again here.

    is_sde = _prob isa SDEProblem

    # ── Alias resolution (SDE/RODE-specific specifier types) ─────────────
    use_old_kwargs = haskey(kwargs, :alias_u0) || haskey(kwargs, :alias_jumps) ||
        haskey(kwargs, :alias_noise)

    if use_old_kwargs
        aliases = ODEAliasSpecifier()
        if haskey(kwargs, :alias_u0)
            message = "`alias_u0` keyword argument is deprecated, to set `alias_u0`,
            please use an SDEAliasSpecifier or RODEAliasSpecifier, e.g. `solve(prob, alias = SDEAliasSpecifier(alias_u0 = true))`"
            Base.depwarn(message, :init)
            Base.depwarn(message, :solve)
            alias_u0 = values(kwargs).alias_u0
        else
            alias_u0 = nothing
        end

        if haskey(kwargs, :alias_jumps)
            message = "`alias_jumps` keyword argument is deprecated, to set `alias_jumps`,
            please use an SDEAliasSpecifier or RODEAliasSpecifier, e.g. `solve(prob, alias = SDEAliasSpecifier(alias_jumps = true))`"
            Base.depwarn(message, :init)
            Base.depwarn(message, :solve)
            alias_jumps = values(kwargs).alias_jumps
        else
            alias_jumps = nothing
        end

        if haskey(kwargs, :alias_noise)
            message = "`alias_noise` keyword argument is deprecated, to set `alias_noise`,
            please use a RODEAliasSpecifier, e.g. `solve(prob, alias = RODEAliasSpecifier(alias_noise = true))`"
            Base.depwarn(message, :init)
            Base.depwarn(message, :solve)
            alias_noise = values(kwargs).alias_noise
        else
            alias_noise = nothing
        end

        aliases = if alias_noise !== nothing
            SciMLBase.RODEAliasSpecifier(; alias_u0, alias_jumps, alias_noise)
        elseif is_sde
            SciMLBase.SDEAliasSpecifier(; alias_u0, alias_jumps)
        else
            SciMLBase.RODEAliasSpecifier(; alias_u0, alias_jumps)
        end

    else
        if alias isa Bool
            aliases = is_sde ? SciMLBase.SDEAliasSpecifier(; alias) :
                SciMLBase.RODEAliasSpecifier(; alias)
        elseif alias isa SciMLBase.SDEAliasSpecifier
            aliases = alias
        elseif alias isa SciMLBase.RODEAliasSpecifier
            aliases = alias
        else
            aliases = is_sde ? SciMLBase.SDEAliasSpecifier() :
                SciMLBase.RODEAliasSpecifier()
        end
    end

    prob = concrete_prob(_prob)

    # ── RNG resolution ───────────────────────────────────────────────────
    _rng, _seed, _rng_provided = _resolve_rng(rng, seed, prob)

    # ── JumpProblem reset ────────────────────────────────────────────────
    if _prob isa JumpProblem
        alias_jumps = isnothing(aliases.alias_jumps) ? Threads.threadid() == 1 :
            aliases.alias_jumps
        _jump_seed = _rng_provided ? nothing : _seed
        if !alias_jumps
            _prob = JumpProcesses.resetted_jump_problem(_prob, _jump_seed)
        else
            JumpProcesses.reset_jump_problem!(_prob, _jump_seed)
        end
    end
    prob = concrete_prob(_prob)

    # ── SDE-specific validation ──────────────────────────────────────────
    if typeof(prob.f) <: Tuple
        if any(mm != I for mm in prob.f.mass_matrix)
            error("This solver is not able to use mass matrices.")
        end
    elseif prob isa DiffEqBase.AbstractRODEProblem && prob.f.mass_matrix != I &&
            !alg_mass_matrix_compatible(alg)
        error("This solver is not able to use mass matrices.")
    end

    if prob isa DiffEqBase.AbstractRODEProblem && typeof(prob.noise) <: NoiseProcess &&
            prob.noise.bridge === nothing && adaptive
        error("Bridge function must be given for adaptivity. Either declare this function in noise process or set adaptive=false")
    end

    if !alg_compatible(_prob, alg)
        error("The algorithm is not compatible with the chosen noise type. Please see the documentation on the solver methods")
    end

    if adaptive && !isadaptive(_prob, alg)
        error("The given solver is a Fixed timestep method and does not support adaptivity.")
    end

    # ── StochasticCompositeAlgorithm AutoSwitch → AutoSwitchCache ────────
    if alg isa StochasticCompositeAlgorithm && alg.choice_function isa AutoSwitch
        auto = alg.choice_function
        alg = StochasticCompositeAlgorithm(
            alg.algs,
            AutoSwitchCache(
                0, 0,
                auto.nonstiffalg,
                auto.stiffalg,
                auto.stiffalgfirst,
                auto.maxstiffstep,
                auto.maxnonstiffstep,
                auto.nonstifftol,
                auto.stifftol,
                auto.dtfac,
                auto.stiffalgfirst,
                auto.switch_max
            )
        )
    end

    # ── f/p/u aliasing (needed before cache construction) ────────────────
    if isnothing(aliases.alias_f) || aliases.alias_f
        f = prob.f
    else
        f = deepcopy(prob.f)
    end

    if isnothing(aliases.alias_p) || aliases.alias_p
        p = prob.p
    else
        p = recursivecopy(prob.p)
    end

    if !isnothing(aliases.alias_u0) && aliases.alias_u0
        u = prob.u0
    else
        u = recursivecopy(prob.u0)
    end

    if prob.u0 isa Tuple
        u = ArrayPartition(prob.u0, Val{true})
    end

    # ── Type computations (needed for cache) ─────────────────────────────
    tType = eltype(prob.tspan)
    uType = typeof(u)
    uBottomEltype = recursive_bottom_eltype(u)
    uBottomEltypeNoUnits = recursive_unitless_bottom_eltype(u)
    uEltypeNoUnits = recursive_unitless_eltype(u)
    tTypeNoUnits = typeof(one(tType))
    noise = prob isa DiffEqBase.AbstractRODEProblem ? prob.noise : nothing
    tspan = prob.tspan
    t = tspan[1]

    # ── SDE-specific abstol/reltol defaults (1//10^2 vs ODE's 1//10^6) ──
    if abstol === nothing
        if uBottomEltypeNoUnits === uBottomEltype && !(uBottomEltype <: Integer)
            abstol = real(convert(uBottomEltype, oneunit(uBottomEltype) * 1 // 10^2))
        elseif uBottomEltype <: Integer
            abstol = real(oneunit(uBottomEltype) * 1 // 10^2)
        else
            abstol = 0
        end
    end

    if reltol === nothing
        if uBottomEltypeNoUnits === uBottomEltype && !(uBottomEltype <: Integer)
            reltol = real(convert(uBottomEltype, oneunit(uBottomEltype) * 1 // 10^2))
        elseif uBottomEltype <: Integer
            reltol = real(oneunit(uBottomEltype) * 1 // 10^2)
        else
            reltol = 0
        end
    end

    # ── rate_prototype / noise_rate_prototype (needed for cache) ─────────
    if isinplace(prob) && u isa AbstractArray && eltype(u) <: Number &&
            uBottomEltypeNoUnits == uBottomEltype
        if !(u isa ArrayPartition)
            rate_prototype = recursivecopy(u)
        else
            rate_prototype = similar(
                u, typeof.(
                    oneunit.(recursive_bottom_eltype.(u.x)) ./
                        oneunit(tType)
                )...
            )
        end
    else
        if uBottomEltypeNoUnits == uBottomEltype
            rate_prototype = u
        else
            rate_prototype = u / oneunit(tType)
        end
    end
    rateType = typeof(rate_prototype)

    if prob.f isa DynamicalSDEFunction
        noise_rate_prototype = rate_prototype.x[1]
    elseif is_diagonal_noise(prob)
        noise_rate_prototype = rate_prototype
    elseif prob isa DiffEqBase.AbstractRODEProblem
        if prob isa DiffEqBase.AbstractSDEProblem
            noise_rate_prototype = copy(prob.noise_rate_prototype)
        else
            noise_rate_prototype = copy(prob.rand_prototype)
        end
    else
        noise_rate_prototype = nothing
    end

    # ── uprev (needed for cache) ─────────────────────────────────────────
    uprev = recursivecopy(u)

    # ── rand_prototype (needed for noise creation) ───────────────────────
    if !(uType <: AbstractArray)
        rand_prototype = zero(u ./ u)
    else
        randElType = uBottomEltypeNoUnits
        if prob.f isa DynamicalSDEFunction
            rand_prototype = copy(noise_rate_prototype)
        elseif is_diagonal_noise(prob)
            if u isa SArray
                rand_prototype = zero(u)
            else
                rand_prototype = (u .- u) ./ sqrt(oneunit(t))
            end
        elseif prob isa DiffEqBase.AbstractSDEProblem
            if issparse(u)
                rand_prototype = adapt(
                    DiffEqBase.parameterless_type(u), zeros(randElType, size(noise_rate_prototype, 2))
                )
            else
                rand_prototype = false .* noise_rate_prototype[1, :]
            end
        elseif prob isa DiffEqBase.AbstractRODEProblem
            rand_prototype = copy(prob.rand_prototype)
        else
            rand_prototype = nothing
        end
    end

    # ── Callback merging for JumpProblem ─────────────────────────────────
    _callback = _prob isa JumpProblem ?
        CallbackSet(callback, _prob.jump_callback) : callback

    # ── Noise creation (WienerProcess / user noise handling) ─────────────
    if prob isa DiffEqBase.AbstractRODEProblem && prob.noise === nothing
        rswm = isadaptive(alg) ? RSWM(adaptivealg = :RSwM3) : RSWM(adaptivealg = :RSwM1)
        if isinplace(prob)
            if alg_needs_extra_process(alg)
                rand_prototype2 = _z_prototype(alg, rand_prototype, true)
                W = WienerProcess!(
                    t, rand_prototype, rand_prototype2,
                    save_everystep = save_noise,
                    rng = _rng
                )
            else
                W = WienerProcess!(
                    t, rand_prototype,
                    save_everystep = save_noise,
                    rng = _rng
                )
            end
        else
            if alg_needs_extra_process(alg)
                rand_prototype2 = _z_prototype(alg, rand_prototype, false)
                W = WienerProcess(
                    t, rand_prototype, rand_prototype2,
                    save_everystep = save_noise,
                    rng = _rng
                )
            else
                W = WienerProcess(
                    t, rand_prototype,
                    save_everystep = save_noise,
                    rng = _rng
                )
            end
        end
    elseif prob isa DiffEqBase.AbstractRODEProblem
        _alias_noise = if hasproperty(aliases, :alias_noise) && aliases.alias_noise !== nothing
            aliases.alias_noise
        else
            true
        end
        W = _alias_noise ? copy(prob.noise) : prob.noise

        if alg_needs_extra_process(alg) && (!hasproperty(W, :dZ) || W.dZ === nothing)
            error("Higher order solver requires extra Brownian process Z. Thus `WienerProcess(t, W0)` is insufficient, you must use `WienerProcess(t, W0, Z0)` where `Z` is another Brownian process")
        end

        if W.reset
            if !_rng_provided && W isa Union{NoiseProcess, NoiseTransport} && W.reseed
                Random.seed!(W.rng, _seed)
            end
            if W.curt != t
                reinit!(W, t, t0 = t)
            end
        elseif W.curt != t
            error("Starting time in the noise process is not the starting time of the simulation. The noise process should be re-initialized for repeated use")
        end
    else
        @assert _prob isa JumpProblem
        W = nothing
    end

    # ── CompoundPoissonProcess for tau-leaping ───────────────────────────
    if _prob isa JumpProblem && _prob.regular_jump !== nothing
        if !isnothing(_prob.regular_jump.mark_dist) == nothing
            error("Mark distributions are currently not supported in SimpleTauLeaping")
        end

        jump_prototype = zeros(_prob.regular_jump.numjumps)
        c = _prob.regular_jump.c

        if isinplace(_prob.regular_jump)
            rate_constants = zeros(_prob.regular_jump.numjumps)
            _prob.regular_jump.rate(rate_constants, u ./ u, prob.p, tspan[1])
            P = CompoundPoissonProcess!(
                _prob.regular_jump.rate, t, jump_prototype,
                computerates = !alg_control_rate(alg) || !adaptive,
                save_everystep = save_noise,
                rng = _rng
            )
            alg_control_rate(alg) && adaptive &&
                P.cache.rate(P.cache.currate, u, p, tspan[1])
        else
            rate_constants = _prob.regular_jump.rate(u ./ u, prob.p, tspan[1])
            P = CompoundPoissonProcess(
                _prob.regular_jump.rate, t, jump_prototype,
                save_everystep = save_noise,
                computerates = !alg_control_rate(alg) || !adaptive,
                rng = _rng
            )
            alg_control_rate(alg) && adaptive &&
                (P.cache.currate = P.cache.rate(u, p, tspan[1]))
        end
    else
        jump_prototype = nothing
        c = nothing
        P = nothing
        rate_constants = nothing
    end

    # ── dW/dZ extraction, verbose conversion, alg_cache ──────────────────
    dW, dZ = isnothing(W) ? (nothing, nothing) : (W.dW, W.dZ)

    verbose_internal = if verbose isa Bool
        verbose ? DEVerbosity(Standard()) : DEVerbosity(None())
    elseif verbose isa AbstractVerbosityPreset
        DEVerbosity(verbose)
    elseif verbose isa DEVerbosity
        verbose
    else
        throw(ArgumentError("verbose must be a Bool, AbstractVerbosityPreset, or DEVerbosity"))
    end

    cache = alg_cache(
        alg, prob, u, dW, dZ, p, rate_prototype, noise_rate_prototype,
        jump_prototype, uEltypeNoUnits, uBottomEltypeNoUnits,
        tTypeNoUnits, uprev, f, t, dt, Val{isinplace(_prob)}, verbose_internal
    )

    # ── Controller computation ───────────────────────────────────────────
    QT = tTypeNoUnits <: Integer ? typeof(qmin) : tTypeNoUnits

    if (beta1 !== nothing || beta2 !== nothing) && controller !== nothing
        throw(
            ArgumentError(
                "Setting both the legacy PID parameters `beta1, beta2 = $((beta1, beta2))` and the `controller = $controller` is not allowed."
            )
        )
    end

    if (beta1 !== nothing || beta2 !== nothing)
        message = "Providing the legacy PID parameters `beta1, beta2` is deprecated. Use the keyword argument `controller` instead."
        Base.depwarn(message, :init)
        Base.depwarn(message, :solve)
    end

    if controller === nothing
        controller = default_controller(alg, cache, QT(qoldinit), beta1, beta2)
    end

    # ── Delegate to ODE's _ode_init directly ─────────────────────────────
    ode_alias = ODEAliasSpecifier(alias_u0 = true, alias_f = true, alias_p = true)

    tType = eltype(prob.tspan)

    integrator = OrdinaryDiffEqCore._ode_init(
        prob, alg;
        # Pre-built objects
        _cache = cache,
        _u = u,
        _uprev = uprev,
        W = W, P = P,
        sqdt = tType(dt),
        noise = noise, c = c, rate_constants = rate_constants,
        seed = _seed,
        rng = _rng,
        controller = controller,
        # SDE-specific defaults (passed through from SDE's kwargs)
        saveat, tstops, d_discontinuities,
        save_idxs, save_everystep, save_noise, save_on,
        save_start, save_end, callback = _callback,
        dense, calck, dt = iszero(dt) ? nothing : dt, adaptive,
        abstol, reltol,
        gamma = nothing, qmin = nothing, qmax = nothing,
        qsteady_min = nothing, qsteady_max = nothing,
        beta1 = nothing, beta2 = nothing, qoldinit = nothing,
        fullnormalize, failfactor,
        delta = convert.(uBottomEltypeNoUnits, delta),
        maxiters, dtmax, dtmin,
        internalnorm, isoutofdomain, unstable_check,
        verbose, force_dtmin,
        timeseries_errors, dense_errors,
        advance_to_tstop, stop_at_next_tstop,
        initialize_save, progress, progress_steps,
        progress_name, progress_message, progress_id,
        userdata, save_discretes, initialize_integrator,
        alias = ode_alias,
        initializealg,
        kwargs...
    )

    # ── Post-delegation: noise process next-step setup ───────────────────
    DiffEqNoiseProcess.setup_next_step!(integrator::SDEIntegrator)

    return integrator
end

# solve! is now provided by OrdinaryDiffEqCore (SciMLBase.solve!(::ODEIntegrator))
# handle_dt! and initialize_callbacks! are now provided by OrdinaryDiffEqCore

# _initialize_dae! for RODE/SDDE problem types that ODE doesn't know about.

function OrdinaryDiffEqCore._initialize_dae!(
        integrator::Union{SDEIntegrator, AbstractSDDEIntegrator},
        prob::Union{SciMLBase.AbstractRODEProblem, SciMLBase.AbstractSDDEProblem},
        ::OrdinaryDiffEqCore.DefaultInit, isinplace
    )
    return if SciMLBase.has_initializeprob(prob.f)
        OrdinaryDiffEqCore._initialize_dae!(integrator, prob, SciMLBase.OverrideInit(), isinplace)
    elseif SciMLBase.__has_mass_matrix(prob.f) && !(prob.f.mass_matrix isa LinearAlgebra.UniformScaling)
        OrdinaryDiffEqCore._initialize_dae!(integrator, prob, SciMLBase.CheckInit(), isinplace)
    end
end

## SciMLBase Trait Definitions

SciMLBase.allows_late_binding_tstops(::StochasticDiffEqAlgorithm) = true
SciMLBase.allows_late_binding_tstops(::StochasticDiffEqRODEAlgorithm) = true

SciMLBase.supports_solve_rng(
    ::SciMLBase.AbstractSDEProblem,
    ::StochasticDiffEqAlgorithm,
) = true

SciMLBase.supports_solve_rng(
    ::SciMLBase.AbstractRODEProblem,
    ::StochasticDiffEqRODEAlgorithm,
) = true

function SciMLBase.isautodifferentiable(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
            StochasticDiffEqJumpAlgorithm,
        }
    )
    return true
end
function SciMLBase.allows_arbitrary_number_types(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
            StochasticDiffEqJumpAlgorithm,
        }
    )
    return true
end
function SciMLBase.allowscomplex(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
            StochasticDiffEqJumpAlgorithm,
        }
    )
    return true
end
SciMLBase.isdiscrete(alg::StochasticDiffEqJumpAlgorithm) = true

function SciMLBase.forwarddiffs_model(
        alg::Union{
            StochasticDiffEqNewtonAlgorithm,
            StochasticDiffEqNewtonAdaptiveAlgorithm, StochasticDiffEqJumpNewtonAdaptiveAlgorithm,
            StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm,
        }
    )
    return OrdinaryDiffEqCore.alg_autodiff(alg) isa ADTypes.AutoForwardDiff
end

# Required for initialization, because ODECore._initialize_dae! calls it during
# OverrideInit
function OrdinaryDiffEqCore.has_autodiff(
        ::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
            StochasticDiffEqJumpAlgorithm,
        }
    )
    return false
end
for T in [
        StochasticDiffEqNewtonAlgorithm, StochasticDiffEqNewtonAdaptiveAlgorithm,
        StochasticDiffEqJumpNewtonAdaptiveAlgorithm,
        StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm,
    ]
    @eval OrdinaryDiffEqCore.has_autodiff(::$T) = true
end

_alg_autodiff(::StochasticDiffEqNewtonAlgorithm{T, AD}) where {T, AD} = Val{AD}()
_alg_autodiff(::StochasticDiffEqNewtonAdaptiveAlgorithm{T, AD}) where {T, AD} = Val{AD}()
function _alg_autodiff(::StochasticDiffEqJumpNewtonAdaptiveAlgorithm{T, AD}) where {T, AD}
    return Val{AD}()
end
function _alg_autodiff(
        ::StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm{
            T, AD,
        }
    ) where {T, AD}
    return Val{AD}()
end
_alg_autodiff(alg::StochasticCompositeAlgorithm) = _alg_autodiff(alg.algs[end])

function OrdinaryDiffEqCore.alg_autodiff(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    ad = _alg_autodiff(alg)
    if ad == Val(false)
        return ADTypes.AutoFiniteDiff()
    elseif ad == Val(true)
        return ADTypes.AutoForwardDiff()
    else
        return SciMLBase._unwrap_val(ad)
    end
end

isadaptive(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = false
function isadaptive(
        alg::Union{
            StochasticDiffEqAdaptiveAlgorithm, StochasticDiffEqRODEAdaptiveAlgorithm,
            StochasticDiffEqJumpAdaptiveAlgorithm,
            StochasticDiffEqJumpDiffusionAdaptiveAlgorithm,
        }
    )
    return true
end
function isadaptive(
        alg::Union{
            StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm,
        }
    )
    return all(isadaptive.(alg.algs))
end
function isadaptive(
        prob, alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    return isadaptive(alg)
end

## StochasticDiffEq Internal Traits

function qmax_default(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm})
    return isadaptive(alg) ? 9 // 8 : 0
end
function qmin_default(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm})
    return isadaptive(alg) ? 1 // 5 : 0
end

delta_default(alg) = 1 // 1

function OrdinaryDiffEqCore.gamma_default(
        alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}
    )
    return isadaptive(alg) ? 9 // 10 : 0
end

ispredictive(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = false
isstandard(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = false
function qsteady_min_default(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    return 1
end
function qsteady_max_default(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    return 1
end

# Extend ODE's isaposteriori for SDE algorithms — default is false.
# Solver subpackages may extend for specific algorithms (e.g., CaoTauLeaping).

# SDE algorithms never extrapolate (no uprev2 storage).
OrdinaryDiffEqCore.alg_extrapolates(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = false

# SDE algorithms are never FSAL (update_fsal! is a no-op for SDE).
OrdinaryDiffEqCore.isfsal(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = false

# Composite alg_order fallback
function alg_order(
        alg::Union{
            StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm,
        }
    )
    return maximum(alg_order.(alg.algs))
end
get_current_alg_order(alg::StochasticDiffEqAlgorithm, cache) = alg_order(alg)
get_current_alg_order(alg::StochasticDiffEqRODEAlgorithm, cache) = alg_order(alg)
function get_current_alg_order(
        alg::Union{
            StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm,
        },
        cache
    )
    return alg_order(alg.algs[cache.current])
end

function beta2_default(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm})
    return isadaptive(alg) ? 2 // (5alg_order(alg)) : 0
end
function beta1_default(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}, beta2)
    return isadaptive(alg) ? 7 // (10alg_order(alg)) : 0
end

isdtchangeable(alg::Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}) = true

# Default alg_interpretation — Ito for SDE.
# Solver subpackages override for Stratonovich methods.
function SciMLBase.alg_interpretation(alg::StochasticDiffEqAlgorithm)
    return SciMLBase.AlgorithmInterpretation.Ito
end

# Default alg_compatible — false for abstract SDE type, true for RODE
function alg_compatible(
        prob, alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    return true
end
alg_compatible(prob, alg::StochasticDiffEqAlgorithm) = false

function alg_compatible(
        prob::DiffEqBase.AbstractSDEProblem,
        alg::Union{
            StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm,
        }
    )
    return max((alg_compatible(prob, a) for a in alg.algs)...)
end

# Trait: whether an algorithm supports regular jumps in a JumpProblem.
# Default is false; EM and ImplicitEM override to true in their subpackages.
supports_regular_jumps(alg) = false

# JumpProblem compatibility defaults
function alg_compatible(prob::JumpProblem, alg::StochasticDiffEqAlgorithm)
    return alg_compatible(prob.prob, alg) &&
        (supports_regular_jumps(alg) || prob.regular_jump === nothing) &&
        prob.prob isa DiffEqBase.AbstractSDEProblem
end

function alg_compatible(
        prob::JumpProblem,
        alg::Union{StochasticDiffEqJumpAdaptiveAlgorithm, StochasticDiffEqJumpAlgorithm}
    )
    return prob.prob isa DiscreteProblem
end

function alg_needs_extra_process(
        alg::Union{
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm,
        }
    )
    return false
end
function alg_needs_extra_process(
        alg::Union{
            StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm,
        }
    )
    return max((alg_needs_extra_process(a) for a in alg.algs)...)
end

function OrdinaryDiffEqCore.get_current_alg_autodiff(alg::StochasticDiffEqCompositeAlgorithm, cache)
    return OrdinaryDiffEqCore.alg_autodiff(alg.algs[cache.current])
end

function OrdinaryDiffEqCore.get_chunksize(
        alg::StochasticDiffEqNewtonAlgorithm{
            CS, AD, FDT, ST, CJ, Controller,
        }
    ) where {CS, AD, FDT, ST, CJ, Controller}
    return Val(CS)
end
function OrdinaryDiffEqCore.get_chunksize(
        alg::StochasticDiffEqNewtonAdaptiveAlgorithm{
            CS, AD, FDT, ST, CJ, Controller,
        }
    ) where {CS, AD, FDT, ST, CJ, Controller}
    return Val(CS)
end
function OrdinaryDiffEqCore.get_chunksize(
        alg::StochasticDiffEqJumpNewtonAdaptiveAlgorithm{
            CS, AD, FDT, ST, CJ, Controller,
        }
    ) where {CS, AD, FDT, ST, CJ, Controller}
    return Val(CS)
end
function OrdinaryDiffEqCore.get_chunksize(
        alg::StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm{
            CS, AD, FDT, ST, CJ, Controller,
        }
    ) where {CS, AD, FDT, ST, CJ, Controller}
    return Val(CS)
end

@static if isdefined(OrdinaryDiffEqCore, :standardtag)
    OrdinaryDiffEqCore.standardtag(
        alg::Union{
            StochasticDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ, Controller},
            StochasticDiffEqNewtonAlgorithm{CS, AD, FDT, ST, CJ, Controller},
        }
    ) where {CS, AD, FDT, ST, CJ, Controller} = ST
end

@static if isdefined(OrdinaryDiffEqCore, :alg_difftype)
    OrdinaryDiffEqCore.alg_difftype(
        alg::Union{
            StochasticDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ, Controller},
            StochasticDiffEqNewtonAlgorithm{CS, AD, FDT, ST, CJ, Controller},
        }
    ) where {
        CS, AD, FDT, ST, CJ, Controller,
    } = FDT
end

@static if isdefined(OrdinaryDiffEqCore, :concrete_jac)
    OrdinaryDiffEqCore.concrete_jac(
        alg::Union{
            StochasticDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ, Controller},
            StochasticDiffEqNewtonAlgorithm{CS, AD, FDT, ST, CJ, Controller},
        }
    ) where {
        CS, AD, FDT, ST, CJ, Controller,
    } = CJ
end

alg_mass_matrix_compatible(alg::StochasticDiffEqAlgorithm) = false
alg_mass_matrix_compatible(alg::StochasticDiffEqRODEAlgorithm) = false
alg_can_repeat_jac(alg::StochasticDiffEqAlgorithm) = true

function alg_mass_matrix_compatible(
        alg::Union{
            StochasticDiffEqNewtonAlgorithm, StochasticDiffEqNewtonAdaptiveAlgorithm,
        }
    )
    if alg.symplectic
        return true
    elseif alg.theta == 1
        return true
    else
        error("Algorithm must be set as symplectic or theta=1 for mass matrices")
    end
end

is_split_step(::StochasticDiffEqAlgorithm) = false

alg_stability_size(alg::StochasticDiffEqAlgorithm) = 0 # default, overridden per-alg

# is_composite_algorithm trait is defined in OrdinaryDiffEqCore and extended in
# integrator_utils.jl for SDE composite algorithm types.
function unwrap_alg(integrator, is_nlsolve)
    alg = integrator.alg
    if !is_composite_algorithm(alg)
        return alg
    elseif alg.choice_function isa AutoSwitchCache
        num = is_nlsolve ? 2 : 1
        if num == 1
            return alg.algs[1]
        elseif num == 2
            return alg.algs[2]
        else
            return alg.algs[num]
        end
    else
        if integrator.cache.current == 1
            return alg.algs[1]
        elseif integrator.cache.current == 2
            return alg.algs[2]
        else
            return alg.algs[integrator.cache.current]
        end
    end
end

alg_control_rate(::StochasticDiffEqAlgorithm) = false
alg_control_rate(::StochasticDiffEqRODEAlgorithm) = false

mutable struct StochasticCompositeCache{T, F} <: StochasticDiffEqCache
    caches::T
    choice_function::F
    current::Int
end

function alg_cache(
        alg::algType,
        prob,
        u,
        ΔW,
        ΔZ,
        p,
        rate_prototype,
        noise_rate_prototype,
        jump_rate_prototype,
        ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits},
        uprev,
        f,
        t,
        dt,
        ::Type{Val{T}},
        verbose
    ) where {
        T, algType <: StochasticCompositeAlgorithm,
        uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits,
    }
    caches = map(
        (x) -> alg_cache(
            x, prob, u, ΔW, ΔZ, p, rate_prototype, noise_rate_prototype,
            jump_rate_prototype, uEltypeNoUnits, uBottomEltypeNoUnits,
            tTypeNoUnits, uprev, f, t, dt, Val{T}, verbose
        ),
        alg.algs
    )
    return StochasticCompositeCache(caches, alg.choice_function, 1)
end

# All abstract algorithm types are now defined in OrdinaryDiffEqCore and imported
# via StochasticDiffEqCore.jl (including Newton/Jump subtypes).

abstract type IteratedIntegralApprox end

struct IICommutative <: IteratedIntegralApprox end
struct IILevyArea <: IteratedIntegralApprox end

struct StochasticCompositeAlgorithm{T, F} <: StochasticDiffEqCompositeAlgorithm
    algs::T
    choice_function::F
end

const SplitSDEAlgorithms = Union{}  # Extended by solver subpackages via Union

module StochasticDiffEqCore

using Reexport
@reexport using DiffEqBase

import ADTypes

import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: ODEIntegrator,
    StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqCompositeAlgorithm,
    StochasticDiffEqRODEAlgorithm, StochasticDiffEqRODEAdaptiveAlgorithm,
    StochasticDiffEqRODECompositeAlgorithm,
    StochasticDiffEqNewtonAdaptiveAlgorithm, StochasticDiffEqNewtonAlgorithm,
    StochasticDiffEqJumpAlgorithm, StochasticDiffEqJumpAdaptiveAlgorithm,
    StochasticDiffEqJumpNewtonAdaptiveAlgorithm,
    StochasticDiffEqJumpDiffusionAlgorithm, StochasticDiffEqJumpDiffusionAdaptiveAlgorithm,
    StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm,
    StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    default_controller, isstandard, ispredictive,
    beta2_default, beta1_default, gamma_default,
    qmin_default, qmax_default, qsteady_min_default,
    qsteady_max_default,
    stepsize_controller!, accept_step_controller,
    step_accept_controller!,
    step_reject_controller!, PIController, DummyController, issplit

# Import shared loop functions from OrdinaryDiffEqCore.
import OrdinaryDiffEqCore: handle_callbacks!, handle_tstop!,
    solution_endpoint_match_cur_integrator!,
    _savevalues!, _postamble!,
    is_composite_cache, is_composite_algorithm, final_progress,
    loopheader!, loopfooter!, _loopfooter!, _step!, perform_step!,
    isaposteriori,
    increment_accept!, increment_reject!,
    calc_dt_propose!, fix_dt_at_bounds!, modify_dt_for_tstops!,
    log_step!, choose_algorithm!, update_uprev!,
    alg_extrapolates, isfsal,
    accept_noise!, reject_noise!, save_noise!, noise_curt, is_noise_saveable,
    reinit_noise!, _determine_initdt, is_constant_cache,
    handle_callback_modifiers!,
    initialize_callbacks!,
    current_extrapolant, current_extrapolant!

using RecursiveArrayTools, DataStructures
using DiffEqNoiseProcess, Random, ArrayInterface
using SimpleNonlinearSolve, ForwardDiff, StaticArrays, MuladdMacro, FiniteDiff, Base.Threads
using Adapt

import DiffEqBase: ODE_DEFAULT_NORM, ODE_DEFAULT_ISOUTOFDOMAIN,
    ODE_DEFAULT_PROG_MESSAGE, ODE_DEFAULT_UNSTABLE_CHECK

using SciMLOperators: MatrixOperator, WOperator

using DiffEqBase: TimeGradientWrapper, UJacobianWrapper, TimeDerivativeWrapper,
    UDerivativeWrapper

import RecursiveArrayTools: chain

using Logging, SparseArrays

using SciMLLogging: AbstractVerbositySpecifier, AbstractVerbosityPreset,
    AbstractMessageLevel, None, Minimal, Standard, Detailed, All,
    Silent, DebugLevel, InfoLevel, WarnLevel, ErrorLevel, @SciMLMessage

using OrdinaryDiffEqCore: DEVerbosity

using LinearAlgebra, Random

import ForwardDiff.Dual

import FastPower

import DiffEqBase: step!, initialize!, DEAlgorithm,
    AbstractSDEAlgorithm, AbstractRODEAlgorithm, DEIntegrator,
    DECache, AbstractSDEIntegrator, AbstractRODEIntegrator,
    AbstractContinuousCallback,
    Tableau, AbstractSDDEIntegrator

# Integrator Interface
import DiffEqBase: resize!, deleteat!, addat!, full_cache, user_cache, u_cache, du_cache,
    rand_cache, ratenoise_cache,
    resize_non_user_cache!, deleteat_non_user_cache!, addat_non_user_cache!,
    terminate!, get_du, get_dt, get_proposed_dt, set_proposed_dt!,
    u_modified!, savevalues!, add_tstop!, add_saveat!, set_reltol!,
    set_abstol!, postamble!, last_step_failed, has_Wfact, has_jac,
    get_tstops, get_tstops_array, get_tstops_max

using DiffEqBase: check_error!, is_diagonal_noise, @..

using OrdinaryDiffEqCore: set_new_W!, get_W, _vec, _reshape

if isdefined(OrdinaryDiffEqCore, :FastConvergence)
    using OrdinaryDiffEqCore:
        FastConvergence, Convergence, SlowConvergence,
        VerySlowConvergence, Divergence

    import OrdinaryDiffEqCore:
        calculate_residuals, calculate_residuals!, nlsolve_f,
        unwrap_cache, islinear
else
    using DiffEqBase:
        FastConvergence, Convergence, SlowConvergence, VerySlowConvergence,
        Divergence

    import DiffEqBase:
        calculate_residuals, calculate_residuals!, nlsolve_f, unwrap_cache,
        islinear
end

import SciMLBase
import SciMLBase: isadaptive, alg_order

using StochasticDiffEqLevyArea

const CompiledFloats = Union{Float32, Float64}

import JumpProcesses
import JumpProcesses: JumpProblem

import Base.Threads
@static if VERSION < v"1.3"
    seed_multiplier() = Threads.threadid()
else
    seed_multiplier() = 1
end

include("misc_utils.jl")
include("algorithms.jl")
include("caches/cache_types.jl")
include("integrators/type.jl")
include("alg_utils.jl")
include("integrators/stepsize_controllers.jl")
include("integrators/integrator_utils.jl")
include("integrators/integrator_interface.jl")
include("initialize_dae.jl")
include("solve.jl")
include("perform_step/composite.jl")
include("iterated_integrals.jl")
include("composite_algs.jl")
include("weak_utils.jl")

export StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqCompositeAlgorithm,
    StochasticDiffEqRODEAlgorithm, StochasticDiffEqRODEAdaptiveAlgorithm,
    StochasticDiffEqRODECompositeAlgorithm

export StochasticDiffEqNewtonAdaptiveAlgorithm, StochasticDiffEqNewtonAlgorithm,
    StochasticDiffEqJumpAlgorithm, StochasticDiffEqJumpAdaptiveAlgorithm,
    StochasticDiffEqJumpNewtonAdaptiveAlgorithm,
    StochasticDiffEqJumpDiffusionAlgorithm, StochasticDiffEqJumpDiffusionAdaptiveAlgorithm,
    StochasticDiffEqJumpNewtonDiffusionAdaptiveAlgorithm

export IteratedIntegralApprox, IICommutative, IILevyArea

export StochasticCompositeAlgorithm, AutoSwitch, AutoAlgSwitch

export SDEIntegrator, SDEOptions, SDEAlgTypes

# Re-export cache types for solver subpackages
export StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    StochasticCompositeCache

# Export core utility functions used by solver subpackages
export alg_cache, alg_order, get_current_alg_order, isadaptive,
    alg_compatible, alg_needs_extra_process, supports_regular_jumps,
    alg_mass_matrix_compatible, alg_can_repeat_jac,
    is_split_step, alg_control_rate, delta_default,
    alg_stability_size, unwrap_alg, issplit,
    DiffCache, get_du, get_chunksize, determine_chunksize,
    NLSOLVEJL_SETUP, IIFNLSolveFunc, DiffEqNLSolveTag

# Export iterated integral utilities for solver subpackages
export get_iterated_I, get_iterated_I!, get_Jalg,
    AbstractJ, AbstractJDiagonal, AbstractJCommute,
    JDiagonal_oop, JDiagonal_iip, JCommute_oop, JCommute_iip,
    IteratedIntegralAlgorithm_iip

# Export weak utility functions
export calc_twopoint_random!, calc_twopoint_random,
    calc_threepoint_random!, calc_threepoint_random, Ihat2

# Export noise interface
export resize_noise!, fill_new_noise_caches!,
    deleteat_noise!, addat_noise!

# Export Z prototype dispatch for noise creation
export _z_prototype, concrete_prob, _resolve_rng, _sde_init

# Export TauLeapingDrift for Jump subpackage
export TauLeapingDrift

# General functions
export solve, init, solve!, step!

# Export misc tools (check functions)
export checkSRIOrder, checkSRAOrder

end # module

struct DiffEqNLSolveTag end

struct DiffCache{T <: AbstractArray, S <: AbstractArray}
    du::T
    dual_du::S
end

Base.@pure function DiffCache(T, size, ::Type{Val{chunk_size}}) where {chunk_size}
    DiffCache(
        fill(zero(T), size...),
        fill(zero(Dual{typeof(ForwardDiff.Tag(DiffEqNLSolveTag(), T)), T, chunk_size}), size...)
    )
end

Base.@pure DiffCache(u::AbstractArray) = DiffCache(
    eltype(u), size(u), Val{ForwardDiff.pickchunksize(length(u))}
)
Base.@pure DiffCache(u::AbstractArray, nlsolve) = DiffCache(eltype(u), size(u), Val{get_chunksize(nlsolve)})
Base.@pure DiffCache(u::AbstractArray, T::Type{Val{CS}}) where {CS} = DiffCache(eltype(u), size(u), T)

get_du(dc::DiffCache, ::Type{T}) where {T <: Dual} = dc.dual_du
get_du(dc::DiffCache, T) = dc.du

# Default nlsolve behavior, should be removed

Base.@pure determine_chunksize(u, alg::DEAlgorithm) = determine_chunksize(u, get_chunksize(alg))
Base.@pure function determine_chunksize(u, CS)
    if CS != 0
        return CS
    else
        return ForwardDiff.pickchunksize(length(u))
    end
end

struct NLSOLVEJL_SETUP{CS, AD} end
Base.@pure NLSOLVEJL_SETUP(; chunk_size = 0, autodiff = true) = NLSOLVEJL_SETUP{
    chunk_size, autodiff,
}()

# Wrapper to store the function for use with SimpleNonlinearSolve
struct IIFNLSolveFunc{F}
    f::F
end

function (p::NLSOLVEJL_SETUP{CS, AD})(f_wrapper::IIFNLSolveFunc, u0; kwargs...) where {
        CS, AD,
    }
    f = f_wrapper.f
    # Create a NonlinearProblem-compatible function
    # The IIF methods use f(resid, u) signature (in-place)
    nlf = NonlinearFunction{true}((resid, u, p) -> (f(resid, u); nothing))
    prob = NonlinearProblem(nlf, u0)
    ad = AD ? AutoForwardDiff() : AutoFiniteDiff()
    alg = SimpleTrustRegion(; autodiff = ad)
    sol = solve(prob, alg)
    return sol.u
end

function (p::NLSOLVEJL_SETUP{CS, AD})(::Type{Val{:init}}, f, u0_prototype) where {CS, AD}
    # Return a wrapper that stores the function
    return IIFNLSolveFunc(f)
end

get_chunksize(x) = 0
get_chunksize(x::NLSOLVEJL_SETUP{CS, AD}) where {CS, AD} = CS

macro cache(expr)
    name = expr.args[2].args[1].args[1]
    fields = expr.args[3].args[2:2:end]
    cache_vars = Expr[]
    rand_vars = Expr[]
    jac_vars = Pair{Symbol, Expr}[]
    ratenoise_vars = Expr[]
    for x in fields
        if x.args[2] == :uType || x.args[2] == :rateType ||
                x.args[2] == :kType || x.args[2] == :uNoUnitsType #|| x.args[2] == :possibleRateType
            push!(cache_vars, :(c.$(x.args[1])))
        elseif x.args[2] == :JCType
            push!(cache_vars, :(c.$(x.args[1]).duals...))
        elseif x.args[2] == :GCType
            push!(cache_vars, :(c.$(x.args[1]).duals))
        elseif x.args[2] == :DiffCacheType
            push!(cache_vars, :(c.$(x.args[1]).du))
            push!(cache_vars, :(c.$(x.args[1]).dual_du))
        elseif x.args[2] == :JType || x.args[2] == :WType
            push!(jac_vars, x.args[1] => :(c.$(x.args[1])))
        elseif x.args[2] == :randType
            push!(rand_vars, :(c.$(x.args[1])))
        elseif x.args[2] == :rateNoiseType || x.args[2] == :rateNoiseCollectionType
            # Should be a pair for handling non-diagonal
            push!(ratenoise_vars, :(c.$(x.args[1])))
        end
    end
    return esc(
        quote
            $expr
            full_cache(c::$name) = tuple($(cache_vars...))
            jac_iter(c::$name) = tuple($(jac_vars...))
            rand_cache(c::$name) = tuple($(rand_vars...))
            ratenoise_cache(c::$name) = tuple($(ratenoise_vars...))
        end
    )
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

if TEST_GROUP == "ALL" || TEST_GROUP == "Core"
    @time @safetestset "Module loads and types" begin
        using StochasticDiffEqCore
        using Test

        @testset "Module loads" begin
            @test isdefined(StochasticDiffEqCore, :SDEIntegrator)
            @test isdefined(StochasticDiffEqCore, :StochasticDiffEqAlgorithm)
            @test isdefined(StochasticDiffEqCore, :StochasticDiffEqAdaptiveAlgorithm)
            @test isdefined(StochasticDiffEqCore, :StochasticCompositeAlgorithm)
            @test isdefined(StochasticDiffEqCore, :IICommutative)
            @test isdefined(StochasticDiffEqCore, :IILevyArea)
            @test isdefined(StochasticDiffEqCore, :AutoSwitch)
        end

        @testset "Abstract type hierarchy" begin
            @test StochasticDiffEqNewtonAdaptiveAlgorithm <: StochasticDiffEqAdaptiveAlgorithm
            @test StochasticDiffEqNewtonAlgorithm <: StochasticDiffEqAlgorithm
            @test StochasticDiffEqJumpAlgorithm <: StochasticDiffEqAlgorithm
            @test StochasticDiffEqJumpAdaptiveAlgorithm <: StochasticDiffEqAlgorithm
        end

        @testset "Iterated integrals" begin
            @test IICommutative() isa IteratedIntegralApprox
            @test IILevyArea() isa IteratedIntegralApprox
        end
    end
end

const SDEAlgTypes = Union{StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm}
const SDEIntegrator = ODEIntegrator{<:SDEAlgTypes}
# Backwards-compatibility alias for downstream packages (e.g. StochasticDelayDiffEq)
const SDEOptions = OrdinaryDiffEqCore.DEOptions

@inline function initialize!(integrator, cache::StochasticCompositeCache)
    cache.current = cache.choice_function(integrator)
    return if cache.current == 1
        initialize!(integrator, @inbounds(cache.caches[1]))
    elseif cache.current == 2
        initialize!(integrator, @inbounds(cache.caches[2]))
    else
        initialize!(integrator, @inbounds(cache.caches[cache.current]))
    end
end

@inline function perform_step!(integrator, cache::StochasticCompositeCache)
    return if cache.current == 1
        perform_step!(integrator, @inbounds(cache.caches[1]))
    elseif cache.current == 2
        perform_step!(integrator, @inbounds(cache.caches[2]))
    else
        perform_step!(integrator, @inbounds(cache.caches[cache.current]))
    end
end

# choose_algorithm!, reset_alg_dependent_opts!, and transfer_cache! are now
# provided by OrdinaryDiffEqCore's generic composite infrastructure.
# The generic choose_algorithm!(integrator, cache) fallback in ODE uses the
# is_composite_cache trait to handle StochasticCompositeCache.

# Newton adaptive get_tmp_cache (SDE-specific nlsolver fields):
@inline DiffEqBase.get_tmp_cache(
    integrator, alg::StochasticDiffEqNewtonAdaptiveAlgorithm,
    cache::StochasticDiffEqMutableCache
) = (cache.nlsolver.tmp, cache.nlsolver.ztmp)
@inline DiffEqBase.get_tmp_cache(
    integrator, alg::StochasticCompositeAlgorithm,
    cache::StochasticCompositeCache
) = get_tmp_cache(integrator, alg.algs[1], cache.caches[1])

function full_cache(integrator::StochasticCompositeCache)
    return Iterators.flatten(full_cache(c) for c in integrator.caches)
end

ratenoise_cache(integrator::SDEIntegrator) = ratenoise_cache(integrator.cache)
function ratenoise_cache(integrator::StochasticCompositeCache)
    return Iterators.flatten(ratenoise_cache(c) for c in integrator.caches)
end

rand_cache(integrator::SDEIntegrator) = rand_cache(integrator.cache)
function rand_cache(integrator::StochasticCompositeCache)
    return Iterators.flatten(rand_cache(c) for c in integrator.caches)
end

jac_iter(integrator::SDEIntegrator) = jac_iter(integrator.cache)
function jac_iter(integrator::StochasticCompositeCache)
    return Iterators.flatten(jac_iter(c) for c in integrator.caches)
end

function resize_noise!(integrator, cache, bot_idx, i)
    for c in integrator.W.S₁
        resize!(c[2], i)
        if alg_needs_extra_process(integrator.alg)
            resize!(c[3], i)
        end
        if i >= bot_idx # fill in rands
            fill_new_noise_caches!(integrator, c, c[1], bot_idx:i)
        end
    end
    for c in integrator.W.S₂
        resize!(c[2], i)
        if alg_needs_extra_process(integrator.alg)
            resize!(c[3], i)
        end
        if i >= bot_idx # fill in rands
            fill_new_noise_caches!(integrator, c, c[1], bot_idx:i)
        end
    end
    resize!(integrator.W.dW, i)
    integrator.W.dW[end] = zero(eltype(integrator.u))
    resize!(integrator.W.dWtilde, i)
    integrator.W.dWtilde[end] = zero(eltype(integrator.u))
    resize!(integrator.W.dWtmp, i)
    integrator.W.dWtmp[end] = zero(eltype(integrator.u))
    resize!(integrator.W.curW, i)
    integrator.W.curW[end] = zero(eltype(integrator.u))
    DiffEqNoiseProcess.resize_stack!(integrator.W, i)

    if alg_needs_extra_process(integrator.alg)
        resize!(integrator.W.dZ, i)
        integrator.W.dZ[end] = zero(eltype(integrator.u))
        resize!(integrator.W.dZtilde, i)
        integrator.W.dZtilde[end] = zero(eltype(integrator.u))
        resize!(integrator.W.dZtmp, i)
        integrator.W.dZtmp[end] = zero(eltype(integrator.u))
        resize!(integrator.W.curZ, i)
        integrator.W.curZ[end] = zero(eltype(integrator.u))
    end
    return if i >= bot_idx # fill in rands
        fill!(@view(integrator.W.curW[bot_idx:i]), zero(eltype(integrator.u)))
        if alg_needs_extra_process(integrator.alg)
            fill!(@view(integrator.W.curZ[bot_idx:i]), zero(eltype(integrator.u)))
        end
    end
end

@inline function fill_new_noise_caches!(integrator, c, scaling_factor, idxs)
    return if isinplace(integrator.W)
        integrator.W.dist(
            @view(c[2][idxs]), integrator.W, scaling_factor,
            integrator.u, integrator.p, integrator.t, integrator.W.rng
        )
        if alg_needs_extra_process(integrator.alg)
            integrator.W.dist(
                @view(c[3][idxs]), integrator.W, scaling_factor,
                integrator.u, integrator.p, integrator.t, integrator.W.rng
            )
        end
    else
        c[2][idxs] .= integrator.noise(length(idxs), integrator, scaling_factor)
        if alg_needs_extra_process(integrator.alg)
            c[3][idxs] .= integrator.noise(length(idxs), integrator, scaling_factor)
        end
    end
end

function resize_non_user_cache!(integrator::SDEIntegrator, cache, i)
    bot_idx = length(integrator.u) + 1
    if is_diagonal_noise(integrator.sol.prob)
        resize_noise!(integrator, cache, bot_idx, i)
        for c in rand_cache(integrator)
            resize!(c, i)
        end
    end
    for c in ratenoise_cache(integrator)
        resize!(c, i)
    end
    return
end

function deleteat_non_user_cache!(integrator::SDEIntegrator, cache, idxs)
    if is_diagonal_noise(integrator.sol.prob)
        deleteat_noise!(integrator, cache, idxs)
        for c in rand_cache(integrator)
            deleteat!(c, idxs)
        end
    end
    for c in ratenoise_cache(integrator)
        deleteat!(c, idxs)
    end
    return
end

function addat_non_user_cache!(integrator::SDEIntegrator, cache, idxs)
    if is_diagonal_noise(integrator.sol.prob)
        addat_noise!(integrator, cache, idxs)
        for c in rand_cache(integrator)
            addat!(c, idxs)
        end
    end
    for c in ratenoise_cache(integrator)
        addat!(c, idxs)
    end
    return
end

function deleteat_noise!(integrator, cache, idxs)
    for c in integrator.W.S₁
        deleteat!(c[2], idxs)
        if alg_needs_extra_process(integrator.alg)
            deleteat!(c[3], idxs)
        end
    end
    for c in integrator.W.S₂
        deleteat!(c[2], idxs)
        if alg_needs_extra_process(integrator.alg)
            deleteat!(c[3], idxs)
        end
    end
    deleteat!(integrator.W.dW, idxs)
    deleteat!(integrator.W.dWtilde, idxs)
    deleteat!(integrator.W.dWtmp, idxs)
    deleteat!(integrator.W.curW, idxs)
    DiffEqNoiseProcess.resize_stack!(integrator.W, length(integrator.u))

    return if alg_needs_extra_process(integrator.alg)
        deleteat!(integrator.W.curZ, idxs)
        deleteat!(integrator.W.dZtmp, idxs)
        deleteat!(integrator.W.dZtilde, idxs)
        deleteat!(integrator.W.dZ, idxs)
    end
end

function addat_noise!(integrator, cache, idxs)
    for c in integrator.W.S₁
        addat!(c[2], idxs)
        if alg_needs_extra_process(integrator.alg)
            addat!(c[3], idxs)
        end
        fill_new_noise_caches!(integrator, c, c[1], idxs)
    end
    for c in integrator.W.S₂
        addat!(c[2], idxs)
        if alg_needs_extra_process(integrator.alg)
            addat!(c[3], idxs)
        end
        fill_new_noise_caches!(integrator, c, c[1], idxs)
    end

    addat!(integrator.W.dW, idxs)
    integrator.W.dW[idxs] .= zero(eltype(integrator.u))
    addat!(integrator.W.curW, idxs)
    integrator.W.curW[idxs] .= zero(eltype(integrator.u))
    if alg_needs_extra_process(integrator.alg)
        addat!(integrator.W.dZ, idxs)
        integrator.W.dZ[idxs] .= zero(eltype(integrator.u))
        addat!(integrator.W.curZ, idxs)
        integrator.W.curZ[idxs] .= zero(eltype(integrator.u))
    end

    i = length(integrator.u)
    resize!(integrator.W.dWtilde, i)
    resize!(integrator.W.dWtmp, i)
    DiffEqNoiseProcess.resize_stack!(integrator.W, i)
    if alg_needs_extra_process(integrator.alg)
        resize!(integrator.W.dZtmp, i)
        resize!(integrator.W.dZtilde, i)
    end

    # fill in rands
    fill!(@view(integrator.W.curW[idxs]), zero(eltype(integrator.u)))
    return if alg_needs_extra_process(integrator.alg)
        fill!(@view(integrator.W.curZ[idxs]), zero(eltype(integrator.u)))
    end
end

@muladd function calc_twopoint_random!(_dW, sqdt, dW)
    @.. _dW = ifelse(sign(dW) > false, sqdt, -sqdt)
    return nothing
end

@muladd function calc_twopoint_random(sqdt, dW)
    return ifelse(sign(dW) > false, sqdt, -sqdt)
end

function calc_threepoint_random!(_dW, sq3dt, quantile, dW_scaled)
    @. _dW = ifelse(abs(dW_scaled) > -quantile, ifelse(dW_scaled < quantile, -sq3dt, sq3dt), zero(sq3dt))
    return nothing
end

@muladd function calc_threepoint_random(sq3dt, quantile, dW_scaled)
    return ifelse(abs(dW_scaled) > -quantile, ifelse(dW_scaled < quantile, -sq3dt, sq3dt), zero(sq3dt))
end

# Ihat2 function stub: methods are defined in StochasticDiffEqWeak alongside their cache types.
function Ihat2 end

@inline function DiffEqNoiseProcess.setup_next_step!(integrator::SDEIntegrator)
    !isnothing(integrator.W) &&
        DiffEqNoiseProcess.setup_next_step!(integrator.W, integrator.u, integrator.p)
    return !isnothing(integrator.P) &&
        DiffEqNoiseProcess.setup_next_step!(integrator.P, integrator.u, integrator.p)
end

@inline function handle_callback_modifiers!(integrator::SDEIntegrator)
    #integrator.reeval_fsal = true
    return if integrator.P !== nothing && integrator.opts.adaptive
        if integrator.cache isa StochasticDiffEqMutableCache
            oldrate = integrator.P.cache.currate
            integrator.P.cache.rate(oldrate, integrator.u, integrator.p, integrator.t)
        else
            integrator.P.cache.currate = integrator.P.cache.rate(integrator.u, integrator.p, integrator.t)
        end
    end
end

@inline initialize!(integrator, cache::StochasticDiffEqCache, f = integrator.f) = nothing

# TauLeapingDrift: wrapper for tau-leaping drift function used by nlsolver
# Computes drift(u, p, t) = c(u, p, t, rate(u, p, t), nothing)
# where c is the stoichiometry function and rate is the propensity function
struct TauLeapingDrift{C, R, RateCache, IIP}
    c::C              # Stoichiometry function (from integrator.c)
    rate::R           # Rate function (from integrator.P.cache.rate)
    rate_cache::RateCache  # Cache for rate values (for in-place version)
end

# Out-of-place: drift(u, p, t)
function (td::TauLeapingDrift{C, R, Nothing, false})(u, p, t) where {C, R}
    rates = td.rate(u, p, t)
    return td.c(u, p, t, rates, nothing)
end

# In-place: drift(du, u, p, t)
function (td::TauLeapingDrift{C, R, RateCache, true})(du, u, p, t) where {C, R, RateCache}
    td.rate(td.rate_cache, u, p, t)
    td.c(du, u, p, t, td.rate_cache, nothing)
    return nothing
end

# nlsolve_f overrides for ImplicitTauLeaping/ThetaTrapezoidalTauLeaping
# are defined in StochasticDiffEqLeaping alongside their concrete types.

# ============================================================================
# Traits for SDE composite algorithms/caches
# ============================================================================

# Trait: SDE composite algorithm types
function OrdinaryDiffEqCore.is_composite_algorithm(
        alg::Union{StochasticDiffEqCompositeAlgorithm, StochasticDiffEqRODECompositeAlgorithm},
    )
    return true
end

# Trait: SDE composite cache type
OrdinaryDiffEqCore.is_composite_cache(cache::StochasticCompositeCache) = true

# ============================================================================
# Noise interface methods for OrdinaryDiffEqCore's noise functions
# These implement the accept_noise!/reject_noise!/save_noise!/noise_curt/
# is_noise_saveable interface that ODE's unified loop functions call.
# ============================================================================

function OrdinaryDiffEqCore.accept_noise!(W::DiffEqNoiseProcess.AbstractNoiseProcess, dt, u, p, setup)
    return DiffEqNoiseProcess.accept_step!(W, dt, u, p, setup)
end

function OrdinaryDiffEqCore.reject_noise!(W::DiffEqNoiseProcess.AbstractNoiseProcess, dt, u, p)
    return DiffEqNoiseProcess.reject_step!(W, dt, u, p)
end

function OrdinaryDiffEqCore.save_noise!(W::DiffEqNoiseProcess.AbstractNoiseProcess)
    return DiffEqNoiseProcess.save_noise!(W)
end

OrdinaryDiffEqCore.noise_curt(W::DiffEqNoiseProcess.AbstractNoiseProcess) = W.curt

OrdinaryDiffEqCore.is_noise_saveable(W::NoiseProcess) = true
OrdinaryDiffEqCore.is_noise_saveable(W::DiffEqNoiseProcess.AbstractNoiseProcess) = false

# ============================================================================
# is_constant_cache for SDE cache types (needed by ODE's change_t_via_interpolation!)
# ============================================================================

OrdinaryDiffEqCore.is_constant_cache(::StochasticDiffEqConstantCache) = true
OrdinaryDiffEqCore.is_constant_cache(::StochasticDiffEqMutableCache) = false
OrdinaryDiffEqCore.is_constant_cache(cache::StochasticCompositeCache) =
    OrdinaryDiffEqCore.is_constant_cache(cache.caches[1])

# ============================================================================
# reinit_noise!: reinitialize noise process (called from ODE's reinit!)
# ============================================================================

function OrdinaryDiffEqCore.reinit_noise!(W::DiffEqNoiseProcess.AbstractNoiseProcess, dt)
    return DiffEqNoiseProcess.reinit!(W, dt)
end

# _determine_initdt: SDE extension (called from ODE's auto_dt_reset!)
function OrdinaryDiffEqCore._determine_initdt(integrator::SDEIntegrator)
    prob = integrator.sol.prob
    if prob isa SciMLBase.AbstractRODEProblem
        return OrdinaryDiffEqCore.ode_determine_initdt(
            integrator.u, integrator.t,
            integrator.tdir, integrator.opts.dtmax,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, prob,
            get_current_alg_order(integrator.alg, integrator.cache),
            integrator
        )
    else
        # TauLeaping/CaoTauLeaping use DiscreteProblem (no f.g or f.mass_matrix),
        # so neither sde_ nor ode_determine_initdt applies. Return a small dt.
        return integrator.tdir * integrator.opts.dtmax / convert(typeof(integrator.t), 1.0e6)
    end
end

"""
All stochastic iterated integrals are written in Stratonovich sense as indicated
by the J.
"""

abstract type AbstractJ end

# Iterated stochastic integral (for diagonal and commutative noise processes where the Levy area approximation is not required.)
abstract type AbstractJDiagonal <: AbstractJ end
abstract type AbstractJCommute <: AbstractJ end

struct JDiagonal_oop <: AbstractJDiagonal end

mutable struct JDiagonal_iip{JType} <: AbstractJDiagonal
    J::JType
    JDiagonal_iip(ΔW) = new{typeof(ΔW)}(false .* ΔW .* ΔW)
end

struct JCommute_oop <: AbstractJCommute end

mutable struct JCommute_iip{JType} <: AbstractJCommute
    J::JType
    function JCommute_iip(ΔW)
        J = false .* vec(ΔW) .* vec(ΔW)'
        return new{typeof(J)}(J)
    end
end

function get_iterated_I(dt, dW, dZ, alg::JDiagonal_oop, p = nothing, c = 1, γ = 1 // 1)
    return 1 // 2 .* dW .* dW
end

function get_iterated_I!(dt, dW, dZ, alg::JDiagonal_iip, p = nothing, c = 1, γ = 1 // 1)
    (; J) = alg
    if dW isa Number
        alg.J = 1 // 2 .* dW .^ 2
    else
        @.. J = 1 // 2 * dW^2
    end
    return nothing
end

function get_iterated_I(dt, dW, dZ, alg::JCommute_oop, p = nothing, c = 1, γ = 1 // 1)
    J = 1 // 2 .* vec(dW) .* vec(dW)'
    return J
end

function get_iterated_I!(dt, dW, dZ, alg::JCommute_iip, p = nothing, c = 1, γ = 1 // 1)
    (; J) = alg
    mul!(J, vec(dW), vec(dW)')
    @.. J *= 1 // 2
    return nothing
end

# algs from StochasticDiffEqLevyArea (originally LevyArea.jl), see e.g.
# https://github.com/stochastics-uni-luebeck/LevyArea.jl/blob/68c5cb08ab103b4dcd3178651f7a5dd9ce8c666d/src/milstein.jl#L25
function get_iterated_I(
        dt, dW, dZ, alg::StochasticDiffEqLevyArea.AbstractIteratedIntegralAlgorithm,
        p = nothing, c = 1, γ = 1 // 1
    )
    if isnothing(p)
        ε = c * dt^(γ + 1 // 2)
        p = terms_needed(length(dW), dt, ε, alg, MaxL2())
    end
    I = StochasticDiffEqLevyArea.levyarea(dW / √dt, p, alg)
    return I .= 1 // 2 * dW .* dW' .+ dt .* I
end

mutable struct IteratedIntegralAlgorithm_iip{JType, levyalgType} <:
    StochasticDiffEqLevyArea.AbstractIteratedIntegralAlgorithm
    J::JType
    levyalg::levyalgType
    function IteratedIntegralAlgorithm_iip(ΔW, levyalg)
        J = false .* vec(ΔW) .* vec(ΔW)'
        return new{typeof(J), typeof(levyalg)}(J, levyalg)
    end
end

function get_iterated_I!(
        dt, dW, dZ, alg::IteratedIntegralAlgorithm_iip, p = nothing, c = 1, γ = 1 // 1
    )
    (; J, levyalg) = alg
    if isnothing(p)
        ε = c * dt^(γ + 1 // 2)
        p = terms_needed(length(dW), dt, ε, levyalg, MaxL2())
    end
    J .= StochasticDiffEqLevyArea.levyarea(dW / √dt, p, levyalg)
    J .= 1 // 2 * dW .* dW' .+ dt .* J
    return nothing
end

# Default algorithms, keep KPWJ_oop() to have a non-mutating version
function get_Jalg(ΔW, dt, prob, alg)
    return if alg.ii_approx isa IILevyArea
        if isinplace(prob)
            if ΔW isa Number || is_diagonal_noise(prob)
                return JDiagonal_iip(ΔW)
            else
                # optimal_algorithm(dim, stepsize, eps=stepsize^(3/2), norm=MaxL2())
                return IteratedIntegralAlgorithm_iip(ΔW, StochasticDiffEqLevyArea.optimal_algorithm(length(ΔW), dt))
            end
        else
            if ΔW isa Number || is_diagonal_noise(prob)
                return JDiagonal_oop()
            else
                return StochasticDiffEqLevyArea.optimal_algorithm(length(ΔW), dt)
            end
        end
    elseif alg.ii_approx isa IICommutative
        if isinplace(prob)
            if ΔW isa Number || is_diagonal_noise(prob)
                return JDiagonal_iip(ΔW)
            else
                return JCommute_iip(ΔW)
            end
        else
            if ΔW isa Number || is_diagonal_noise(prob)
                return JDiagonal_oop()
            else
                return JCommute_oop()
            end
        end
    else
        if isinplace(prob)
            IteratedIntegralAlgorithm_iip(ΔW, alg.ii_approx)
        else
            return alg.ii_approx
        end
    end
end

# Specific Levy area alg for an SDE solver
# function StochasticDiffEq.get_Jalg(ΔW,prob,alg::SOLVER)
#  return MronRoe()
# end

mutable struct AutoSwitchCache{nAlg, sAlg, tolType, T}
    count::Int
    successive_switches::Int
    nonstiffalg::nAlg
    stiffalg::sAlg
    is_stiffalg::Bool
    maxstiffstep::Int
    maxnonstiffstep::Int
    nonstifftol::tolType
    stifftol::tolType
    dtfac::T
    stiffalgfirst::Bool
    switch_max::Int
end

struct AutoSwitch{nAlg, sAlg, tolType, T}
    nonstiffalg::nAlg
    stiffalg::sAlg
    maxstiffstep::Int
    maxnonstiffstep::Int
    nonstifftol::tolType
    stifftol::tolType
    dtfac::T
    stiffalgfirst::Bool
    switch_max::Int
end
function AutoSwitch(
        nonstiffalg, stiffalg; maxstiffstep = 10, maxnonstiffstep = 3,
        nonstifftol = 9 // 10, stifftol = 9 // 10, dtfac = 2, stiffalgfirst = false,
        switch_max = 5
    )
    return AutoSwitch(
        nonstiffalg, stiffalg, maxstiffstep, maxnonstiffstep,
        promote(nonstifftol, stifftol)..., dtfac, stiffalgfirst, switch_max
    )
end

function is_stiff(integrator, alg, ntol, stol, is_stiffalg)
    eigen_est, dt = integrator.eigen_est, integrator.dt
    stiffness = abs(eigen_est * dt / alg_stability_size(alg)) # `abs` here is just for safety
    tol = is_stiffalg ? stol : ntol
    os = oneunit(stiffness)
    bool = stiffness > os * tol

    if !bool
        integrator.alg.choice_function.successive_switches += 1
    else
        integrator.alg.choice_function.successive_switches = 0
    end

    integrator.do_error_check = integrator.alg.choice_function.successive_switches >
        integrator.alg.choice_function.switch_max || !bool
    return bool
end

function (AS::AutoSwitchCache)(integrator)
    integrator.iter == 0 && return Int(AS.stiffalgfirst) + 1
    dt = integrator.dt
    # Successive stiffness test positives are counted by a positive integer,
    # and successive stiffness test negatives are counted by a negative integer
    AS.count = is_stiff(
            integrator, AS.nonstiffalg, AS.nonstifftol, AS.stifftol, AS.is_stiffalg
        ) ?
        AS.count < 0 ? 1 : AS.count + 1 :
        AS.count > 0 ? -1 : AS.count - 1
    if (!AS.is_stiffalg && AS.count > AS.maxstiffstep)
        integrator.dt = dt * AS.dtfac
        AS.is_stiffalg = true
    elseif (AS.is_stiffalg && AS.count < -AS.maxnonstiffstep)
        integrator.dt = dt / AS.dtfac
        AS.is_stiffalg = false
    end
    return Int(AS.is_stiffalg) + 1
end

function AutoAlgSwitch(nonstiffalg, stiffalg; kwargs...)
    AS = AutoSwitch(nonstiffalg, stiffalg; kwargs...)
    return StochasticCompositeAlgorithm((nonstiffalg, stiffalg), AS)
end

# AutoSOSRI2/AutoSOSRA2 are defined in the StochasticDiffEq umbrella package
# since they reference concrete types from multiple solver subpackages.
